<script lang="ts">
	export let variant: 'contained' | 'outlined' = 'contained';
	export let color: 'primary' | 'secondary' = 'primary';
	export let size: 'small' | 'medium' | 'large' = 'medium';

	const classes = `button ${variant} ${size} ${color}`;
</script>

<button on:click class={classes}>
	<slot />
</button>

<style>
	.button {
		all: unset;
		display: inline-flex;
		align-items: center;
		justify-content: center;
		padding: 0.5rem 1rem;
		border-radius: 0.5rem;
		font-size: 1rem;
		cursor: pointer;

		transition: all 0.1s ease-in-out;
	}

	.button.contained {
		background: var(--color-primary);
		border: 1px solid var(--color-primary);
		color: var(--color-text);
	}
	.button.contained:hover {
		background: var(--color-primary-dark);
		border: 1px solid var(--color-primary-dark);
	}

	.button.outlined {
		background: transparent;
		border: 1px solid var(--color-primary);
		color: var(--color-primary);
	}
	.button.outlined:hover {
		background: var(--color-primary);
		color: var(--color-text);
	}

	.button.small {
		font-size: 0.75rem;
	}

	.button.medium {
		font-size: 1rem;
	}

	.button.large {
		font-size: 1.25rem;
	}
</style>
